/*
 データからdxf(ver2013)ファイルを作成する

   プログラムの作成にあたって
   素人が下手の横好きで動作優先のプログラムを作成していますので、きれいな文法になっていないかもしれません。
 　なおかつ名称も違うかもしれませんが、ご勘弁ください。
   
   "//"のあとが注釈ですが、簡単に記載していますのでご容赦ください。

 */

// JREシステムライブラリー
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


//外部ライブラリー：SWT
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Label;

public class Dxfdraw2013 extends SelectionAdapter {

	// 種々の定義

			DxfR2013 dxf = new DxfR2013() ;						// ライブラリーDxfR2013の定義(使用可能にする)

			private Display display ;
			private Text field [] = new Text [20] ;
			private Button [] button = new Button [20] ;
			static int ku1 , ku2 , ku3 , ku4 , ku5 , ku6 , ku7 , nerep ,lgat , itit ;
			static String filems1 , filems2 , filems3 , filems4 , filems5 , pathn ;
			private Group gr ;
			private Button [] rbun = new Button [10] ;
			private Label label ;

			private String [] nalayer = new String [1000] ;		// LAYER名
			private String [] selayer = new String [1000] ;		// 線種
			private int    [] irnola = new int [1000] ;			// 色番号
			private int    [] futosa = new int [1000] ;			// 線太さ
			private int    [] printy = new int [1000] ;			// 印刷有無

			private String line ;								// 読み込み１行データ
			private String [][] data = new String [50000][30] ;	// 読み込み１行データの代入先
			private String [] la = new String [50000] ;			// 画層名
			private String [] se = new String [50000] ;			// 線種
			private int    [] ir = new int [50000] ;			// 色番号
			private int    [] fu = new int [50000] ;			// 線太さ

			private int [] pkous = new int [50000] ;			// ポリラインの頂点数
			private int [] tojik = new int [50000] ;			// ポリラインの終端処理(閉じる閉じない)
			private double [] x1 = new double [50000] ;			// 始点ｘ
			private double [] y1 = new double [50000] ;			// 始点ｙ
			private double [] z1 = new double [50000] ;			// 始点ｚ
			private double [] x2 = new double [50000] ;			// 終点ｘ
			private double [] y2 = new double [50000] ;			// 終点ｙ
			private double [] z2 = new double [50000] ;			// 終点ｚ
			private double [][] x3 = new double [1000][250] ;	// ポリラインの頂点ｘ
			private double [][] y3 = new double [1000][250] ;	// ポリラインの頂点ｙ

			private String [] s1 = new String [50000] ;			// 文字列
			private String [] s7 = new String [50000] ;			// 文字スタイル

			private String [] sf3    = new String [100] ;		// 1バイトフォント名
			private String [] sf4    = new String [100] ;		// 2バイトフォント名
			private String [] sf1000 = new String [100] ;		// TrueType

			private double [] d40 = new double [50000] ;		// 文字の高さ
			private double [] d41 = new double [50000] ;		// 参照矩形の幅
			private double [] d42 = new double [50000] ;		// 最後に使用された高さ
			private double [] d44 = new double [50000] ;		// マルチテキスト行間隔係数

			private double [] d46 = new double [50000] ;		// ブロックの回転角度
			private double [] d50 = new double [50000] ;		// 文字の回転角度
			private double [] d51 = new double [50000] ;		// 文字の傾斜角度

			private int [] i71 = new int [50000] ;				// マルチテキスト アタッチされる点
			private int [] i72 = new int [50000] ;				// 水平方向の文字位置合わせ
			private int [] i73 = new int [50000] ;				// 垂直位置合わせ
//			private int [] now = new int [50000] ;				// 番号

			static int isw  , isw0 ;
			private String filem , filem0 , filem1, filem2, filem3, filem4, filem5, filem6, filem7 ;
			private int kline , gkosu , nota ;

	public static void main( String[] args ) {					// main
		new Dxfdraw2013();
	}

	// 入力画面の設定
	Dxfdraw2013() {
			int hstart = 10 ;
			int hy0 = 18 ;	// 行高さ
			int hy1 = 5 ;	// 行間
			int hy2 = 60 ;	// 行間
			int []he = new int [40] ;
		for(int i = 0 ; i < 40 ; i++) {
			if (i==0) {
				he[i] = hstart ;
			} else {
				he[i] = he[i-1] + hy0 + hy1 ;
			}
		}

		// タイトル
			display = new Display();
			Shell shell = new Shell(display);
			shell.setText("dxfファイル作成");
			Color red = new Color(display,255,  0,  0);

		// 入力画面(ボタンとフィールドの設定)
			button[0] = new Button(shell, SWT.PUSH | SWT.MULTI | SWT.WRAP);
			button[0].setText("レイヤー");
			button[0].setBounds(10, he[5], 60, 40);
			button[0].addSelectionListener(this);
			field[0] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[0].setTextLimit(200);
			field[0].setBounds(75, he[5]-10, 400, hy2);

			button[1] = new Button(shell, SWT.PUSH | SWT.MULTI | SWT.WRAP);
			button[1].setText("文字スタイル");
			button[1].setBounds(10, he[8], 60, 40);
			button[1].addSelectionListener(this);
			field[1] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[1].setTextLimit(200);
			field[1].setBounds(75, he[8]-10, 400, hy2);

			button[2] = new Button(shell, SWT.PUSH | SWT.MULTI | SWT.WRAP);
			button[2].setText("線 分");
			button[2].setBounds(10, he[11], 60, 40);
			button[2].addSelectionListener(this);
			field[2] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[2].setTextLimit(200);
			field[2].setBounds(75, he[11]-10, 400, 55);

			button[3] = new Button(shell, SWT.PUSH  | SWT.MULTI | SWT.WRAP);
			button[3].setText("ﾎﾟﾘﾗｲﾝ");
			button[3].setBounds(10, he[14], 60, 40);
			button[3].addSelectionListener(this);
			field[3] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[3].setTextLimit(200);
			field[3].setBounds(75, he[14]-10, 400, hy2);

			button[4] = new Button(shell, SWT.PUSH  | SWT.MULTI | SWT.WRAP);
			button[4].setText("円・円弧");
			button[4].setBounds(10, he[17], 60, 40);
			button[4].addSelectionListener(this);
			field[4] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[4].setTextLimit(200);
			field[4].setBounds(75, he[17]-10, 400, 55);

			button[5] = new Button(shell, SWT.PUSH );
			button[5].setText("テキスト");
			button[5].setBounds(10, he[20], 60, 40);
			button[5].addSelectionListener(this);
			field[5] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[5].setTextLimit(200);
			field[5].setBounds(75, he[20]-10, 400, hy2);

			button[6] = new Button(shell, SWT.PUSH | SWT.MULTI | SWT.WRAP);
			button[6].setText("マルチテキスト");
			button[6].setBounds(10, he[23], 60, 40);
			button[6].addSelectionListener(this);
			field[6] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[6].setTextLimit(200);
			field[6].setBounds(75, he[23]-10, 400, hy2);

			button[7] = new Button(shell, SWT.PUSH | SWT.MULTI | SWT.WRAP);
			button[7].setText("点");
			button[7].setBounds(10, he[26], 60, 40);
			button[7].addSelectionListener(this);
			field[7] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[7].setTextLimit(200);
			field[7].setBounds(75, he[26]-10, 400, hy2);

			button[8] = new Button(shell, SWT.PUSH | SWT.MULTI | SWT.WRAP);
			button[8].setText("楕 円");
			button[8].setBounds(10, he[29], 60, 40);
			button[8].addSelectionListener(this);
			field[8] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[8].setTextLimit(200);
			field[8].setBounds(75, he[29]-10, 400, hy2);

			gr = new Group(shell,SWT.NONE);
			gr.setText("フォルダ選択");
			gr.setBounds(50,he[1], 130,70);

			rbun[0] = new Button(gr,SWT.RADIO);
			rbun[0].setText("データ抽出箇所");
			rbun[0].setBounds(15,20, 110, 25);
			rbun[0].setSelection(true);
			rbun[0].addSelectionListener(this);
			rbun[1] = new Button(gr,SWT.RADIO);
			rbun[1].setText("programと一緒");
			rbun[1].setBounds(15, 40, 110, 25);
			rbun[1].addSelectionListener(this);
			label = new Label(shell,SWT.NULL | SWT.WRAP);
			label.setText("描画の際に必要なファイルのフォルダ位置");
			label.setBounds(30,he[0], 400, 55);
			label.setForeground(red);
			
			label = new Label(shell,SWT.NULL);
			label.setText("データがあるもののみ入力");
			label.setBounds(325,he[4]-10, 145, 20);
			label.setForeground(red);

			button[9] = new Button(shell, SWT.PUSH);
			button[9].setText("dxf作成");
			button[9].setBounds(290, he[32]-10, 80, 25);
			button[9].addSelectionListener(this);

			button[10] = new Button(shell, SWT.PUSH);
			button[10].setText("終　了");
			button[10].setBounds(390, he[32]-10, 80, 25);
			button[10].addSelectionListener(this);

			shell.setBounds(0,0,500,810);	// 画面の大きさ
			shell.open();
		while(!shell.isDisposed()){
			if (!display.readAndDispatch()){
				display.sleep();
			}
		}
	}

	// buttonの動作の定義
	public void widgetSelected(SelectionEvent e) {

		// button[0]の動作
		if (e.getSource() == button[0]){							// button[0]が押されたら
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem = dialog.open();									// データファイル名の取得
			pathn = dialog.getFilterPath()+"\\" ;					// そのフォルダ名の取得
			field[0].setText(filem);								// ファイル名をフィールドに表示
			filems1=pathn+"drawing_2013.dxf" ;						// 作成するdxfファイル名(合体後)
			filems2=pathn+"layer.txt" ;								// LAYERのdxfファイル名
			filems3=pathn+"style.txt" ;								// STYLEのdxfファイル名
			filems4=pathn+"entities.txt" ;							// entitiesのdxfファイル名
			filems5=pathn+"z4_ラストno.txt" ;							// ハンドル番号最大値のファイル名
			

			// 描画の際に必要なファイルあるフォルダの指定
			if (rbun[0].getSelection()){							// rbun[0]が押されたら
				itit=0 ;
				isw0=fileRead0(filems5)+1 ;							// ハンドル番号の最大値の取得
			}

			if (rbun[1].getSelection()){							// rbun[1]が押されたら
				itit=1 ;
				isw0=2000000 ;										// ハンドル番号の初期値
			}
//			System.out.println(isw0) ;
			
			layer(filem) ;											// LAYERのdxfファイルを作成する
			shell2.dispose() ;
			ku1=0 ;
			ku2=0 ;
			ku3=0 ;
			ku4=0 ;
			ku5=0 ;
			ku6=0 ;
			ku7=0 ;
		}

		// button[1]の動作
		if (e.getSource() == button[1]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem0 = dialog.open();									// データファイル名の取得
			field[1].setText(filem0);								// ファイル名をフィールドに表示
			style(filem0) ;											// STYLEのdxfファイルを作成する
			shell2.dispose() ;
		}

		// button[2]の動作
		if (e.getSource() == button[2]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem1 = dialog.open();									// データファイル名の取得
			field[2].setText(filem1);								// ファイル名をフィールドに表示
			Line(filem1);											// 線分Rのdxfファイルを作成する
			shell2.dispose() ;
			ku1=1 ;
		}

		// button[3]の動作
		if (e.getSource() == button[3]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem2 = dialog.open();									// データファイル名の取得
			field[3].setText(filem2);								// ファイル名をフィールドに表示
			Polyline(filem2);										// ポリラインのdxfファイルを作成する
			shell2.dispose() ;
			ku2=1 ;
		}

		// button[4]の動作
		if (e.getSource() == button[4]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem3 = dialog.open();									// データファイル名の取得
			field[4].setText(filem3);								// ファイル名をフィールドに表示
			Circle(filem3);											// 円・円弧のdxfファイルを作成する
			shell2.dispose() ;
			ku3=1 ;
		}

		// button[5]の動作
		if (e.getSource() == button[5]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem4 = dialog.open();									// データファイル名の取得
			field[5].setText(filem4);								// ファイル名をフィールドに表示
			Text(filem4);											// テキストのdxfファイルを作成する
			shell2.dispose() ;
			ku4=1 ;
		}

		// button[6]の動作
		if (e.getSource() == button[6]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem5 = dialog.open();									// データファイル名の取得
			field[6].setText(filem5);								// ファイル名をフィールドに表示
			MText(filem5);											// マルチテキストLAYERのdxfファイルを作成する
			shell2.dispose() ;
			ku5=1 ;
		}

		// button[7]の動作
		if (e.getSource() == button[7]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem6 = dialog.open();									// データファイル名の取得
			field[7].setText(filem6);								// ファイル名をフィールドに表示
			Point(filem6);											// 点Rのdxfファイルを作成する
			shell2.dispose() ;
			ku6=1 ;
		}

		// button[8]の動作
		if (e.getSource() == button[8]){
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem7 = dialog.open();									// データファイル名の取得
			field[8].setText(filem7);								// ファイル名をフィールドに表示
			Ellipse(filem7);										// 楕円のdxfファイルを作成する
			shell2.dispose() ;
			ku7=1 ;
		}

		// button[9]の動作
		if (e.getSource() == button[9]){
				dxf.file_e() ;										// ライブラリーDxfR2013のfile_e()実施(ENTITIESファイルのクローズ)

				isw=isw+1 ;
//				System.out.println(isw) ;
			FileRead2013 obj1 = new FileRead2013();					// FileRead2013を定義(使用可能にする)
			obj1.main(isw);											// 各々のdxfファイルを合体し"drawing_2013.dxf"を作成する
		}

		// button[10]の動作
		if (e.getSource() == button[10]){
			menuFileExit();											// 終了する
		}
	}

	// 終了の設定
	public void menuFileExit() {
		System.exit(0);
	}
	
	// ハンドル番号 の取得
	public int fileRead0(String str) {											//　int(整数)を戻り値に定義
				int ver=0 ;														// 戻り値の変数(AC1027のうちの1027とか)
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);					// 読み込みファイルの定義
				InputStreamReader in = new InputStreamReader(fis,"SJIS");		// 読み込み時の文字コードの定義
				BufferedReader br = new BufferedReader(in);						// 1行単位の読み込みを定義

						line = br.readLine() ;									// lineに１行文字列を代入する
						ver = (int) Double.parseDouble(line) ;					// ハンドル番号の最大値

				br.close(); 													// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
		System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}
				return ver ;													// 戻る
	}

	// LAYERデータ
	public void layer(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
					br.readLine() ;
					br.readLine() ;											// データファイルの頭2行を読み飛ばす

					kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
					kline=kline+1 ;											// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//				now[i]=(int) Double.parseDouble(data[i][0]) ;		// No
				nalayer[i]=data[i][1] ;								// 画層名
				irnola[i]=(int) Double.parseDouble(data[i][2]) ;	// 色番号
				selayer[i]=data[i][3] ;								// 線種名
				futosa[i]=(int) Double.parseDouble(data[i][4]) ;	// 線太さ
				printy[i]=(int) Double.parseDouble(data[i][5]) ;	// 印刷有無
			}
				br.close(); 										// ファイルのクローズ
				nerep=kline+1 ;
				// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

		// レイヤー設定 **************************************************************
					dxf.layer_fs() ;								// LAYER dxfファイルの開始f
						isw=isw0 ;									// ハンドル番号の初期値
//						System.out.printf("%d レイヤー数 %d%n",isw,kline+1);
					dxf.table_layer_s(isw,kline+1) ;				// LAYER個数の記載

				for(int i = 0 ; i < kline+1 ; i++) {
						isw=isw+1 ;									// ハンドル番号のカウンター
						dxf.table_layer(isw,nalayer[i],irnola[i],selayer[i],futosa[i],printy[i]) ;		// LAYER の個々のdxfデータ化
				}
					dxf.endtab() ;									// LAYERデータの終了処理

					dxf.file_e() ;									// LAYER dxfファイルの終了
	}

	// STYLEデータ
	public void style(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
					br.readLine() ;
					br.readLine() ;											// データファイルの頭2行を読み飛ばす

					kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
					kline=kline+1 ;											// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//				now[i]=(int) Double.parseDouble(data[i][0]) ;				// No

				if (data[i][1].length()==0) {
					s7[i]="null" ;
				} else {
					s7[i]=data[i][1] ;
				}

				d40[i]=Double.parseDouble(data[i][2]) ;		// 高さ
				d41[i]=Double.parseDouble(data[i][3]) ;		// 幅係数
				d50[i]=Double.parseDouble(data[i][4]) ;		// 傾斜角度
				d42[i]=Double.parseDouble(data[i][5]) ;		// 最後に使用された高さ
//				System.out.println(data[i][6].length()) ;
//				System.out.println(data[i][6]) ;
				if (data[i][6].length()==0) {
					sf3[i]="null" ;
				} else {
					sf3[i]=data[i][6] ;						// 1バイトコードのフォント名
				}
//				System.out.println(data[i][7].length()) ;
//				System.out.println(data[i][7]) ;
				if (data[i][7].length()==0) {
					sf4[i]="null" ;
				} else {
					sf4[i]=data[i][7] ;						// ２バイトコードのフォント名
				}
//				System.out.println(data[i][8].length()) ;
//				System.out.println(data[i][8]) ;
				if (data[i][8].length()==0) {
					sf1000[i]="null" ;
				} else {
					sf1000[i]=data[i][8] ;					// TrueTypeフォント
				}
/*
				System.out.println(data[i][0]) ;
				System.out.println(data[i][1]) ;
				System.out.println(data[i][2]) ;
				System.out.println(data[i][3]) ;
				System.out.println(data[i][4]) ;
				System.out.println(data[i][5]) ;
				System.out.println(data[i][6]) ;
				System.out.println(data[i][7]) ;
				System.out.println(data[i][8]) ;
*/
				i71[i]=(int) Double.parseDouble(data[i][9]) ; //1071
/*
				System.out.println(data[i][9]) ;
				System.out.printf("%d %s %f %f %f %f %s %s %s %d%n",now[i],s7[i],d40[i],d41[i],d50[i],d42[i],sf3[i],sf4[i],sf1000[i],i71[i]) ;
*/
			}
				br.close(); // ファイルのクローズ

				// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

		// 文字スタイル設定 **************************************************************
					dxf.style_fs() ;					// STYLE dxfファイルの開始f
						isw=isw+1 ;						// ハンドル番号のカウンター
					dxf.table_style_s(isw,kline+1) ;	// STYLE個数の記載

				for(int i = 0 ; i < kline+1 ; i++) {
						isw=isw+1 ;						// ハンドル番号のカウンター
						dxf.table_style(isw,s7[i],d40[i],d41[i],d50[i],d42[i],sf3[i],sf4[i],sf1000[i],i71[i]) ;		// STYLE の個々のdxfデータ化
				}
//					dxf.endtab() ;						// STYLEデータの終了処理

					dxf.file_e() ;						// STYLE dxfファイルの終了

					dxf.entities_s() ;					// entities dxfファイルの開始
//					isw = 100000 ;
	}

	// 線分LINERデータ
	public void Line(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
				br.readLine() ;
				br.readLine() ;												// データファイルの頭2行を読み飛ばす

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
					kline=kline+1 ;											// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//				now[i]=(int) Double.parseDouble(data[i][0]) ;		// No
				x1[i]=Double.parseDouble(data[i][1]) ;				// 始点x値
				y1[i]=Double.parseDouble(data[i][2]) ;				// 始点y値
				z1[i]=Double.parseDouble(data[i][3]) ;				// 始点z値
				x2[i]=Double.parseDouble(data[i][4]) ;				// 終点x値
				y2[i]=Double.parseDouble(data[i][5]) ;				// 終点y値
				z2[i]=Double.parseDouble(data[i][6]) ;				// 終点z値
				fu[i]=(int) Double.parseDouble(data[i][7]) ;		// 線太さ
				ir[i]=(int) Double.parseDouble(data[i][8]) ;		// 色番号
				se[i]=data[i][9] ;									// 線種名
				la[i]=data[i][10] ;									// 画層名
			}
				br.close(); // ファイルのクローズ

				// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

		// dxf描画 **************************************************************

//				dxf.entit_s() ;						// ENTITIES Section の開始
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < kline+1 ; i++) {
					isw=isw+1 ;						// ハンドル番号のカウンター
					String aname = la[i] ;					// 画層名
					double xs = x1[i] ;						// 始点x値
					double ys = y1[i] ;						// 始点y値
					double zs = z1[i] ;						// 始点z値
					double xe = x2[i] ;						// 終点x値
					double ye = y2[i] ;						// 終点y値
					double ze = z2[i] ;						// 終点z値

					for(int l = 0 ; l < nerep ; l++) {		// 線種名・色番号・線太さのBylayerの判定
						if (nalayer[l].equals(la[i])) {
							lgat=l ;
						};
					}
						if (selayer[lgat].equals(se[i])) {
							sesyu="gatti" ;
						} else {
							sesyu=se[i] ;					// 線種名
						}
						if (irnola[lgat]==ir[i]) {
							iro=0 ;
						} else {
							iro=ir[i] ;						// 色番号
						}
						if (futosa[lgat]==fu[i]) {
							futo=0 ;
						} else {
							futo=fu[i] ;					// 線太さ
						}
					dxf.entit_line(isw,aname,xs,ys,zs,xe,ye,ze,sesyu,iro,futo) ;
				}
	}

	// ポリラインデータ
	public void Polyline(String str) { 
		// データの取り込み
				double []xp = new double [1000] ;
				double []yp = new double [1000] ;
//				double []zp = new double [1000] ;
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
						kline=kline+1 ;										// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}
							nota=-1 ; 
			for(int i = 0 ; i < kline+1 ; i++) {
							nota=nota+1 ;
						pkous[nota]=(int) Double.parseDouble(data[i][1]) ;		// 頂点個数
						tojik[nota]=(int) Double.parseDouble(data[i][2]) ;		// 閉じる閉じない
						fu[nota]=(int) Double.parseDouble(data[i][3]) ;			// 線太さ
						ir[nota]=(int) Double.parseDouble(data[i][4]) ;			// 色番号
						se[nota]=data[i][5] ;									// 線種名
						la[nota]=data[i][6] ;									// 画層名

						int kdt = pkous[nota] ;
				for(int l = 0 ; l < kdt ; l++) {
							i++ ;
						x3[nota][l]=Double.parseDouble(data[i][1]) ;			// x値
						y3[nota][l]=Double.parseDouble(data[i][2]) ;			// y値
				}
			}
				br.close(); // ファイルのクローズ
		// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

		// dxf描画 **************************************************************
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < nota+1 ; i++) {
						isw=isw+1 ;
						int nn = pkous[i] ;						// 頂点個数
						int tj = tojik[i] ;						// 閉じる閉じない
						String aname = la[i] ;					// 画層名

						for(int l = 0 ; l < nerep ; l++) {		// 線種名・色番号・線太さのBylayerの判定
							if (nalayer[l].equals(la[i])) {
								lgat=l ;
							};
						}
							if (selayer[lgat].equals(se[i])) {
								sesyu="gatti" ;
							} else {
								sesyu=se[i] ;					// 線種名
							}
							if (irnola[lgat]==ir[i]) {
								iro=0 ;
							} else {
								iro=ir[i] ;						// 色番号
							}
							if (futosa[lgat]==fu[i]) {
								futo=0 ;
							} else {
								futo=fu[i] ;					// 線太さ
							}
							
					for(int l = 0 ; l < nn ; l++) {
						xp[l] = x3[i][l] ;					// x値
						yp[l] = y3[i][l] ;					// y値
//						zp[l] = 0 ;
					}

					dxf.entit_polyline(isw,aname,nn,tj,xp,yp,sesyu,iro,futo) ;
				}
	}

	// 円・円弧データの書き込み
	public void Circle(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
				br.readLine() ;
				br.readLine() ;												// データファイルの頭2行を読み飛ばす

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
						kline=kline+1 ;										// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//					now[i]=(int) Double.parseDouble(data[i][0]) ;	// No
					x1[i]=Double.parseDouble(data[i][1]) ;			// x値
					y1[i]=Double.parseDouble(data[i][2]) ;			// y値
					z1[i]=Double.parseDouble(data[i][3]) ;			// z値
					d40[i]=Double.parseDouble(data[i][4]) ;			// 半径

					d50[i]=Double.parseDouble(data[i][5]) ;			// 開始角度(°)
					d51[i]=Double.parseDouble(data[i][6]) ;			// 終了角度(°)
					fu[i]=(int) Double.parseDouble(data[i][7]) ;	// 線太さ
					ir[i]=(int) Double.parseDouble(data[i][8]) ;	// 色番号
					se[i]=data[i][9] ;								// 線種名
					la[i]=data[i][10] ;								// 画層名
			}
				br.close(); // ファイルのクローズ
		// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

			// dxf描画 **************************************************************
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < kline+1 ; i++) {
					isw=isw+1 ;
					double xs = x1[i] ;						// x値
					double ys = y1[i] ;						// y値
					double zs = z1[i] ;						// z値
					double th40 = d40[i] ;					// 半径
					double th50 = d50[i] ;					// 開始角度(°)
					double th51 = d51[i] ;					// 終了角度(°)
					String aname = la[i] ;					// 画層名

					for(int l = 0 ; l < nerep ; l++) {		// 線種名・色番号・線太さのBylayerの判定
						if (nalayer[l].equals(la[i])) {
							lgat=l ;
						};
					}
						if (selayer[lgat].equals(se[i])) {
							sesyu="gatti" ;
						} else {
							sesyu=se[i] ;					// 線種名
						}
						if (irnola[lgat]==ir[i]) {
							iro=0 ;
						} else {
							iro=ir[i] ;						// 色番号
						}
						if (futosa[lgat]==fu[i]) {
							futo=0 ;
						} else {
							futo=fu[i] ;					// 線太さ
						}
						
					dxf.entit_circle(isw,aname,xs,ys,zs,th40,th50,th51,sesyu,iro,futo) ;
				}
	}

	// テキストデータ
	public void Text(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
				br.readLine() ;
				br.readLine() ;												// データファイルの頭2行を読み飛ばす

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
						kline=kline+1 ;										// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//					now[i]=(int) Double.parseDouble(data[i][0]) ; 	// No
					x1[i]=Double.parseDouble(data[i][1]) ;			// x値
					y1[i]=Double.parseDouble(data[i][2]) ;			// y値
					z1[i]=Double.parseDouble(data[i][3]) ;			// z値
					d40[i]=Double.parseDouble(data[i][4]) ;			// 文字高さ
					s1[i]=data[i][5] ;								// 文字列
					d50[i]=Double.parseDouble(data[i][6]) ;			// 回転角度
					d41[i]=Double.parseDouble(data[i][7]) ;			// 幅係数
					d51[i]=Double.parseDouble(data[i][8]) ;			// 傾斜角度
					s7[i]=data[i][9] ;								// 文字スタイル名
					i72[i]=(int)Double.parseDouble(data[i][10]) ; 	// 横位置合わせコード
					x2[i]=Double.parseDouble(data[i][11]) ;			// x値
					y2[i]=Double.parseDouble(data[i][12]) ;			// y値
					z2[i]=Double.parseDouble(data[i][13]) ;			// z値
					i73[i]=(int)Double.parseDouble(data[i][14]) ;	// 縦位置合わせコード
					fu[i]=(int) Double.parseDouble(data[i][15]) ;	// 線太さ
					ir[i]=(int) Double.parseDouble(data[i][16]) ;	// 色番号
					se[i]=data[i][17] ;								// 線種名
					la[i]=data[i][18] ;								// 画層名
			}
				br.close(); // ファイルのクローズ
		// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}
		
		// dxf描画 **************************************************************
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < kline+1 ; i++) {
					isw=isw+1 ;
					double xs10 = x1[i] ;					// x値
					double ys20 = y1[i] ;					// y値
					double zs30 = z1[i] ;					// z値
					double xs11 = x2[i] ;					// x値
					double ys21 = y2[i] ;					// y値
					double zs31 = z2[i] ;					// z値
					double th40 = d40[i] ;					// 文字高さ
					double th50 = d50[i] ;					// 回転角度
					double th51 = d51[i] ;					// 傾斜角度
					double th41 = d41[i] ;					// 幅係数
					String amoji = s1[i] ;					// 文字列
					String astyle = s7[i] ;					// 文字スタイル名
					int iyoko = i72[i] ; 					// 横位置合わせコード
					int itate = i73[i] ;					// 縦位置合わせコード
					String aname = la[i] ;					// 画層名

					for(int l = 0 ; l < nerep ; l++) {		// 線種名・色番号・線太さのBylayerの判定
						if (nalayer[l].equals(la[i])) {
							lgat=l ;
						};
					}
						if (selayer[lgat].equals(se[i])) {
							sesyu="gatti" ;
						} else {
							sesyu=se[i] ;					// 線種名
						}
						if (irnola[lgat]==ir[i]) {
							iro=0 ;
						} else {
							iro=ir[i] ;						// 色番号
						}
						if (futosa[lgat]==fu[i]) {
							futo=0 ;
						} else {
							futo=fu[i] ;					// 線太さ
						}

					if (iyoko==0 && itate==0) {					// 左寄せ
						dxf.entit_text3(isw,aname,xs10,ys20,zs30,th40,amoji,th50,th41,th51,astyle,iyoko,itate,sesyu,iro,futo) ;
					} else if (xs11==0 && ys21==0 && zs31==0) {	// 左寄せの予備
						dxf.entit_text2(isw,aname,xs10,ys20,zs30,th40,amoji,th50,th41,th51,astyle,iyoko,itate,sesyu,iro,futo) ;
					} else {									// 左寄せ以外
						dxf.entit_text(isw,aname,xs10,ys20,zs30,th40,amoji,th50,th41,th51,astyle,iyoko,xs11,ys21,zs31,itate,sesyu,iro,futo) ;
					}
				}
	}

	// マルチテキストデータ
	public void MText(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
				br.readLine() ;
				br.readLine() ;												// データファイルの頭2行を読み飛ばす

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
						kline=kline+1 ;										// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//					now[i]=(int) Double.parseDouble(data[i][0]) ;	// No
					x1[i]=Double.parseDouble(data[i][1]) ;			// x値
					y1[i]=Double.parseDouble(data[i][2]) ;			// y値
					z1[i]=Double.parseDouble(data[i][3]) ;			// z値
					d40[i]=Double.parseDouble(data[i][4]) ;			// 文字高さ
					d50[i]=Double.parseDouble(data[i][5]) ;			// 回転角度
					d41[i]=Double.parseDouble(data[i][6]) ;			// 参照矩形の幅
					d46[i]=Double.parseDouble(data[i][7]) ;			// ブロックの回転角度

					i71[i]=(int) Double.parseDouble(data[i][8]) ; 	// アタッチされる点
					i72[i]=(int) Double.parseDouble(data[i][9]) ; 	// 描画方向
					s1[i]=data[i][10] ;								// 文字列
					s7[i]=data[i][11] ;								// 文字スタイル名

					x2[i]=Double.parseDouble(data[i][12]) ;			// ベクトルx値
					y2[i]=Double.parseDouble(data[i][13]) ;			// ベクトルy値
					z2[i]=Double.parseDouble(data[i][14]) ;			// ベクトルz値
					i73[i]=(int) Double.parseDouble(data[i][15]) ; 	// 行間スタイル
					d44[i]=Double.parseDouble(data[i][16]) ; 		// 行間係数
					fu[i]=(int) Double.parseDouble(data[i][17]) ;	// 線太さ
					ir[i]=(int) Double.parseDouble(data[i][18]) ;	// 色番号
					se[i]=data[i][19] ;								// 線種名
					la[i]=data[i][20] ;								// 画層名
			}
				br.close(); // ファイルのクローズ
		// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

		// dxf描画 **************************************************************
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < kline+1 ; i++) {
					isw=isw+1 ;
					double xs11 = x1[i] ;					// x値
					double ys21 = y1[i] ;					// y値
					double zs31 = z1[i] ;					// z値
					double xs12 = x2[i] ;					// ベクトルx値
					double ys22 = y2[i] ;					// ベクトルy値
					double zs32 = z2[i] ;					// ベクトルz値
					double th40 = d40[i] ;					// 文字高さ
					double th50 = d50[i] ;						// 回転角度
					double th41 = d41[i] ;					// 参照矩形の幅
					double th44 = d44[i] ; 					// 行間係数
					double th46 = d46[i] ;					// ブロックの回転角度
					String amoji = s1[i] ;					// 文字列
					String astyle = s7[i] ;					// 文字スタイル名
					int iyoko = i71[i] ; 					// アタッチされる点
					int itate = i72[i] ; 					// 描画方向
					int gyouk = i73[i] ; 					// 行間スタイル
					String aname = la[i] ;					// 画層名

					for(int l = 0 ; l < nerep ; l++) {		// 線種名・色番号・線太さのBylayerの判定
						if (nalayer[l].equals(la[i])) {
							lgat=l ;
						};
					}
						if (selayer[lgat].equals(se[i])) {
							sesyu="gatti" ;
						} else {
							sesyu=se[i] ;					// 線種名
						}
						if (irnola[lgat]==ir[i]) {
							iro=0 ;
						} else {
							iro=ir[i] ;						// 色番号
						}
						if (futosa[lgat]==fu[i]) {
							futo=0 ;
						} else {
							futo=fu[i] ;					// 線太さ
						}
					dxf.entit_mtext(isw,aname,xs11,ys21,zs31,th40,th50,th41,th46,iyoko,itate,amoji,astyle,xs12,ys22,zs32,gyouk,th44,sesyu,iro,futo) ;
				}
	}

	// 点データ
	public void Point(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
				br.readLine() ;
				br.readLine() ;												// データファイルの頭2行を読み飛ばす

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
						kline=kline+1 ;										// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//					now[i]=(int) Double.parseDouble(data[i][0]) ;	// No
					x1[i]=Double.parseDouble(data[i][1]) ;			// x値
					y1[i]=Double.parseDouble(data[i][2]) ;			// y値
					z1[i]=Double.parseDouble(data[i][3]) ;			// z値
					fu[i]=(int) Double.parseDouble(data[i][4]) ;	// 線太さ
					ir[i]=(int) Double.parseDouble(data[i][5]) ;	// 色番号
					se[i]=data[i][6] ;								// 線種名
					la[i]=data[i][7] ;								// 画層名
			}
				br.close(); // ファイルのクローズ
		// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

			// dxf描画 **************************************************************
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < kline+1 ; i++) {
					isw=isw+1 ;
					double xs = x1[i] ;						// x値
					double ys = y1[i] ;						// y値
					double zs = z1[i] ;						// z値
					String aname = la[i] ;					// 画層名

					for(int l = 0 ; l < nerep ; l++) {		// 線種名・色番号・線太さのBylayerの判定
						if (nalayer[l].equals(la[i])) {
							lgat=l ;
						};
					}
						if (selayer[lgat].equals(se[i])) {
							sesyu="gatti" ;
						} else {
							sesyu=se[i] ;					// 線種名
						}
						if (irnola[lgat]==ir[i]) {
							iro=0 ;
						} else {
							iro=ir[i] ;						// 色番号
						}
						if (futosa[lgat]==fu[i]) {
							futo=0 ;
						} else {
							futo=fu[i] ;					// 線太さ
						}
					dxf.entit_point(isw,aname,xs,ys,zs,sesyu,iro,futo) ;
				}
	}

	// 楕円データ
	public void Ellipse(String str) { 
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);				// 読み込みファイル
				InputStreamReader in = new InputStreamReader(fis,"SJIS");	// 読み込みをShift-JISで
				BufferedReader br = new BufferedReader(in);					// 1行単位の読み込み
				br.readLine() ;
				br.readLine() ;												// データファイルの頭2行を読み飛ばす

				kline=-1 ;
			while ( ( line = br.readLine()) != null ) {						// line に１行文字列を代入する(ファイルの末まで実行する)
						kline=kline+1 ;										// 行のカウンター

					StringTokenizer st = new StringTokenizer(line, ",");	// 1行を","区切りでデータと定義
					gkosu=-1 ;
				while (st.hasMoreTokens()) {								// ","区切りのデータ個数まで
					gkosu=gkosu+1 ;											// 個数のカウンター
					data[kline][gkosu]=st.nextToken().toString();			// dataに文字でデータを代入する(行・個数)
				}
			}

			for(int i = 0 ; i < kline+1 ; i++) {
//					now[i]=(int) Double.parseDouble(data[i][0]) ;		// No
					x1[i]=Double.parseDouble(data[i][1]) ;				// x値(中心)
					y1[i]=Double.parseDouble(data[i][2]) ;				// y値(中心)
					z1[i]=Double.parseDouble(data[i][3]) ;				// z値(中心)
					x2[i]=Double.parseDouble(data[i][4]) ;				// x値(長軸の端点)
					y2[i]=Double.parseDouble(data[i][5]) ;				// y値(長軸の端点)
					z2[i]=Double.parseDouble(data[i][6]) ;				// z値(長軸の端点)

					d40[i]=Double.parseDouble(data[i][7]) ;				// 短軸の比率
					d41[i]=Double.parseDouble(data[i][8]) ;				// 開始角度(ラジアン)
					d42[i]=Double.parseDouble(data[i][9]) ;

					fu[i]=(int) Double.parseDouble(data[i][10]) ;		// 線太さ
					ir[i]=(int) Double.parseDouble(data[i][11]) ;		// 色番号
					se[i]=data[i][12] ;									// 線種名
					la[i]=data[i][13] ;									// 画層名
			}
				br.close(); // ファイルのクローズ
		// エラーがあった場合は、スタックトレースを出力
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}

			// dxf描画 **************************************************************
						String sesyu="syokiti" ;
						int iro=0 ;
						int futo=0 ;
				for(int i = 0 ; i < kline+1 ; i++) {
					isw=isw+1 ;
					double xs11 = x1[i] ;				// x値(中心)
					double ys21 = y1[i] ;				// y値(中心)
					double zs31 = z1[i] ;				// z値(中心)
					double xs12 = x2[i] ;				// x値(長軸の端点)
					double ys22 = y2[i] ;				// y値(長軸の端点)
					double zs32 = z2[i] ;				// z値(長軸の端点)
					double th40 = d40[i] ;				// 短軸の比率
					double th41 = d41[i] ;				// 開始角度(ラジアン)
					double th42 = d42[i] ;				// 終了角度(ラジアン)
					String aname = la[i] ;				// 画層名

					for(int l = 0 ; l < nerep ; l++) {	// 線種名・色番号・線太さのBylayerの判定
						if (nalayer[l].equals(la[i])) {
							lgat=l ;
						}
					}
						if (selayer[lgat].equals(se[i])) {
							sesyu="gatti" ;
						} else {
							sesyu=se[i] ;				// 線種名
						}
						if (irnola[lgat]==ir[i]) {
							iro=0 ;
						} else {
							iro=ir[i] ;					// 色番号
						}
						if (futosa[lgat]==fu[i]) {
							futo=0 ;
						} else {
							futo=fu[i] ;				// 線太さ
						}
					dxf.entit_ellipse(isw,aname,xs11,ys21,zs31,xs12,ys22,zs32,th40,th41,th42,sesyu,iro,futo) ;
				}
	}
}
