/*
 *  データからdxf(ver2013)ファイルを作成する(前段階で作成された個々のファイルを合体させる)
 *    LAYER,SYTLE,LINE,LWPOLYLINE,CIRCLE(円・円弧),TEXT,MTEXT,POINT,ELLIPSE
 */
// JREシステムライブラリー
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

public class FileRead2013 {
		String msg;

	void main(int isws) {
		String filemm=null ;
		try {
			File file = new File(Dxfdraw2013.filems1);							// dxfファイル名の定義
			FileOutputStream fos1 = new FileOutputStream(file);					// 書き込みファイルの定義
			OutputStreamWriter out1 = new OutputStreamWriter(fos1,"UTF-8");		// 書き込み時の文字コードの定義
			PrintWriter pw1 = new PrintWriter(out1);							// 1行単位の書き込みを定義
			
			for (int i=0 ; i<7; i++) {
				if (Dxfdraw2013.itit==0) {
					if (i==0) { filemm=Dxfdraw2013.pathn+"z0_前半1.txt" ; }		// 描画の際に必要なファイルの名称を定義(データ抽出箇所)
					if (i==1) { filemm=Dxfdraw2013.pathn+"z1_前半2.txt" ; }
					if (i==2) { filemm=Dxfdraw2013.filems2 ; }
					if (i==3) { filemm=Dxfdraw2013.filems3 ; }
					if (i==4) { filemm=Dxfdraw2013.pathn+"z2_中間.txt" ; }
					if (i==5) { filemm=Dxfdraw2013.filems4 ; }
					if (i==6) { filemm=Dxfdraw2013.pathn+"z3_後半.txt" ; }
				} else {
					if (i==0) { filemm="y0_前半1.txt" ; }						// 描画の際に必要なファイルの名称を定義(programと一緒)
					if (i==1) { filemm="y1_前半2.txt" ; }
					if (i==2) { filemm=Dxfdraw2013.filems2 ; }
					if (i==3) { filemm=Dxfdraw2013.filems3 ; }
					if (i==4) { filemm="y2_中間.txt" ; }
					if (i==5) { filemm=Dxfdraw2013.filems4 ; }
					if (i==6) { filemm="y3_後半.txt" ; }
				}

			FileInputStream fis = new FileInputStream(filemm);					// 読み込みファイルの定義
			InputStreamReader in = new InputStreamReader(fis,"SJIS");			// 読み込み時の文字コードの定義
			BufferedReader br = new BufferedReader(in);							// 1行単位の読み込みを定義

					while ( ( msg = br.readLine()) != null ) {					// msg に１行文字列を代入する(ファイルの末まで実行する)
							pw1.println(msg) ;									// 	dxfファイルの書き込み
					}
							br.close();											// 読み込みファイルのクローズ

				if (i==0) { 													// $HANDSEED のグループコード「  5」
					String hex = Integer.toHexString(isws);
					pw1.println(hex) ;											// ハンドル番号の最大値+1の書き込み
				}
			}
					pw1.close() ; 												// 書き込みファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.printf("%s ファイルがありません",filemm);
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}
	}
}
